
#ifndef __ISC_ABPROBLEM_H__
#define __ISC_ABPROBLEM_H__

#include "isc.h"
#include "iscInt.h"

#include "utils/assoc.h"

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/**Type***********************************************************************

  Synopsis    [Definition of the public accessor for class IscAbProblem]

  Description []

******************************************************************************/
typedef struct IscAbProblem_TAG* IscAbProblem_ptr;

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/

/**Macros**********************************************************************

  Synopsis    [To cast and check instances of class IscAbProblem]

  Description [These macros must be used respectively to cast and to check
  instances of class IscAbProblem]

******************************************************************************/
#define ISC_ABPROBLEM(self) \
         ((IscAbProblem_ptr) self)

#define ISC_ABPROBLEM_CHECK_INSTANCE(self) \
         (nusmv_assert(ISC_ABPROBLEM(self) != ISC_ABPROBLEM(NULL)))

/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN IscAbProblem_ptr
Isc_AbProblem_Create ARGS((be_ptr A, be_ptr B, int k, BeEnc_ptr be_enc));

EXTERN IscAbProblem_ptr
Isc_AbProblem_Create_List ARGS((Slist_ptr A, be_ptr B, int k, BeEnc_ptr be_enc));

EXTERN void
Isc_AbProblem_Destroy ARGS((IscAbProblem_ptr self));

EXTERN NodeList_ptr
Isc_AbProblem_GetSharedCnfVar ARGS((IscAbProblem_ptr self));

EXTERN be_ptr
Isc_AbProblem_GetBeProblem ARGS((IscAbProblem_ptr self));

EXTERN SatSolverResult
Isc_AbProblem_Solve ARGS((IscAbProblem_ptr self, Trace_ptr* trace,
                          NodeList_ptr trace_symbols));

EXTERN int
Isc_AbProblem_GetNumSharedVariables ARGS((IscAbProblem_ptr self));

EXTERN be_ptr
Isc_AbProblem_GetInterpolant ARGS((IscAbProblem_ptr self));

EXTERN be_ptr
Isc_AbProblem_GetPartialTransitionApproximation ARGS((IscAbProblem_ptr self,
    int time));

EXTERN void
Isc_AbProblem_DumpProblem ARGS((IscAbProblem_ptr self, FILE* out));

EXTERN void
Isc_AbProblem_DumpCnfDescription ARGS((IscAbProblem_ptr self, FILE* out));

/**AutomaticEnd***************************************************************/

#endif

