
#ifndef __ISC_ABPROBLEM_INT_H__
#define __ISC_ABPROBLEM_INT_H__

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/**Type***********************************************************************

  Synopsis    [IscAbProblem class definition]

  Description []

  SeeAlso     []

******************************************************************************/
typedef struct IscAbProblem_TAG
{
  /* general helpers and results */

  /* Also the sat solver instance is part of the abproblem object, since
   * it contains (if problem is UNSAT) the resolution refutation proof. */
  SatSolver_ptr solver;

  SatSolverResult result;

  BeEnc_ptr be_enc;
  Be_Manager_ptr be_mgr;
  BddEnc_ptr bdd_enc;

  /* main attributes */

  int k;

  Slist_ptr beA;
  be_ptr beB;
  be_ptr beProb;

  Slist_ptr cnfA;
  Be_Cnf_ptr cnfB;
}
IscAbProblem;

#endif /* __ISC_ABPROBLEM_INT_H__ */

